unit fTestSrvMain;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, TestSrv_TLB, ExtCtrls;

type
  TfrmTestSrvMain = class(TForm)
    Label1: TLabel;
    Timer1: TTimer;
    procedure FormCreate(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure Timer1Timer(Sender: TObject);
  private
    ClientList: TInterfaceList;
  public
    procedure Add(O: IInterface);
    procedure Delete(O: IInterface);
  end;

var
  frmTestSrvMain: TfrmTestSrvMain;

implementation

uses fTestSrvMainIMPL;

{$R *.dfm}

procedure TfrmTestSrvMain.FormCreate(Sender: TObject);
begin
  Left := 10;
  Top := 10;
  ClientList := TInterfaceList.Create;
  Timer1Timer(nil);
end;

procedure TfrmTestSrvMain.Add(O: IInterface);
begin
  ClientList.Lock;
  try
    ClientList.Add(O);
  finally
    ClientList.Unlock;
  end;
end;

procedure TfrmTestSrvMain.Delete(O: IInterface);
var
  I: Integer;
begin
  ClientList.Lock;
  try
    I := ClientList.IndexOf(O);
    if I > -1 then ClientList.Delete(I);
  finally
    ClientList.Unlock;
  end;
end;

procedure TfrmTestSrvMain.FormClose(Sender: TObject; var Action: TCloseAction);
var
  I: Integer;
  O: IInterface;
begin
  ClientList.Lock;
  try
    for I := ClientList.Count-1 downto 0 do
    begin
      O := ClientList.Items[I];
      try
        ClientList.Delete(I);
      finally
        O := nil;
      end;
    end;
  finally
    ClientList.Unlock;
  end;
  FreeAndNil(ClientList);
end;

procedure TfrmTestSrvMain.Timer1Timer(Sender: TObject);
begin
  Label1.Caption := 'Connection Count = ' + IntToStr(ClientList.Count);
end;

end.
